'******************************************
'**   Tomoritett kep megjelenitese       **
'******************************************
Sub Show_Picture (Byval P_Layer As Byte,  Byval PX1 as word, byval PY1 as byte )

   Local Pixel_BYTE        As Byte
   Local Next_Pixel_BYTE   As Byte
   Local Bit_CT            As Byte
   Local Repeat_CT         As Byte
   Local PX                As Word
   Local PX2               As Word
   Local PY                As Byte
   Local PY2               As Byte
   Local Marker            AS Byte
   Local Tmp_Byte          As Byte 'majd valami

   'Ha nem grafikus layer-re megz a rajz, akkor vege
   If P_Layer > 7 Then Exit Sub

   'A kep mereteinek a beolvasasa
   'X  2 byte
   Read Tmp_Byte
   Read Pixel_BYTE
   PX = Pixel_BYTE * 256
   PX = PX + Tmp_Byte
   'Y  1 byte
   Read PY

   'A max koordinatak kiszamilasa
   PX2 = PX1 + PX
   PX2 = PX2 - 1

   PY2 = PY1  + PY
   PY2 = PY2 - 1

   'Most egyenlore fixen &HFE a jelzo byte
   Marker     = &HFE

   'Valtozok inicializalasa
   Bit_CT     = 0
   Pixel_BYTE = 0
   PY = PY1
   PX = PX1

   'A legelso byte mindenkepp pixel info es azt kiirja
   Read Pixel_BYTE
   Gosub Write_Pixel


   Do
      'A kovetkezo adat beolvasasa
      Read Next_Pixel_BYTE

      If Next_Pixel_BYTE = Marker Then
         If Pixel_BYTE = Marker Then
           'Ha az elozo kiirt pixel byte is jelzo byte volt, akkor
            'a kovetkezot is mindenkepp ki kell irni
            Gosub Write_Pixel
         Else
            Read Repeat_CT
            While Repeat_CT > 0
               Decr Repeat_CT
               Gosub Write_Pixel
            Wend
            Pixel_BYTE = Next_Pixel_BYTE
         End If
      Else
         Pixel_BYTE = Next_Pixel_Byte
         Gosub Write_Pixel
      End If


      If PY > PY2 Then Exit Do
      If PX = PX1 AND PY > PY2 Then Exit Do
      'If PX > PX2 Then Exit Do
      'If PY = PY1 AND PX > PX2 Then Exit Do

   Loop

   Exit Sub

Write_Pixel:
   Bit_CT = 8
   If PY > PY2 Then return
   'If PX > PX2 Then return

   While Bit_CT <> 0
    Decr Bit_CT
      If Pixel_BYTE.Bit_CT <> 0 Then
         'Itt kell meghivni a pixel rajzolo rutint
         'LCD_Plot ( Byval P_Layer As Byte , Byval Write_Mode As Byte, Byval P_X As Word , Byval P_Y As Byte , Byval P_Bright As Byte )
         'PSET( PX, PY ), 15
         LCD_Plot P_Layer, 1, PX, PY, 3 'Feher
      Else
         LCD_Plot P_Layer, 1, PX, PY, 0 'Fekete
      End If
      Incr PX
      If PX > PX2 Then
         PX = PX1
         Incr PY
         If PY > PY2 Then Exit While
      End If
'      Incr PY
'      If PY > PY2 Then
'         PY = PY1
'         Incr PX
'         If PX > PX2 Then Exit While
'      End If
   Wend

   Return


End Sub



'******************************************
'**       Zart alakzat kitoltese.        **
'******************************************
Sub LCD_Fill ( Byval FLayer As Byte, Byval FX As Word, Byval FY As Byte, Byval FBright As Byte )
   Local Bkgrnd As Byte                ' A kiolvasott pixel fenyereje


   Local Stack_Addr As Word
   Local Tmp_Int  As Integer
   Local Step_Int As Integer
   Local XL       As Integer
   Local XR       As Integer
   Local DY       As Integer
   Local X        As Integer
   Local Y        As Integer
   Local X1       As Integer
   Local X2       As Integer
   Local Y1       As Integer
   Local Y2       As Integer
   Local SPP      As Integer
   Local SPP2     As Integer
   Local L        As Integer
   Local F_I      As Integer

   Local Tmp_Word   As Word
   Local Tmp_Byte   As Byte
   Local Tmp1_Byte  As Byte
   Local Tmp2_Byte  As Byte
   Local Tmp1_Word  As Word
   Local Tmp2_Word  As Word


   X = FX : Y = FY
   Tmp_Word = X
   Tmp_Byte = Y


   Bkgrnd = LCD_Point ( FLayer, Tmp_Word, Tmp_Byte )
   If Bkgrnd = FBright Then Exit Sub
   SPP = 0 : SPP2 = 0

   Stack_St( S_YY )  = Y
   Stack_St( S_XL ) = X
   Stack_St( S_XR ) = X
   Stack_St( S_DY ) = 1
   Gosub PUSH_Stack
   SPP = SPP + 1

   Stack_St( S_YY )  = Y + 1
   Stack_St( S_XL ) = X
   Stack_St( S_XR ) = X
   Stack_St( S_DY ) = -1
   Gosub PUSH_Stack
   SPP = SPP + 1

   While SPP2 <> SPP

      Gosub POP_Stack
      DY = Stack_St( S_DY )
      Y  = Stack_St( S_YY ) + DY
      X1 = Stack_St( S_XL )
      X2 = Stack_St( S_XR )
      SPP2 = SPP2 + 1

      If SPP2 > BSize Then SPP2 = 0

      X = X1
      Do
         Tmp1_Byte = Y
         Tmp_Word  = X
         Tmp_Byte  = LCD_Point( FLayer, Tmp_Word, Tmp1_Byte )
         If Tmp_Word > MaxX Or Tmp1_Byte > MaxY Then Tmp_Byte = 255
         If  X > -1  And Tmp_Byte = Bkgrnd  Then X = X - 1 Else Goto WW1
      Loop
WW1:
      If X >= X1 Then Goto Skip
      L = X + 1

      If L < X1 Then
         Stack_St( S_YY )  = Y
         Stack_St( S_XL ) = L
         Stack_St( S_XR ) = X1 - 1
         Stack_St( S_DY ) = -DY
         Gosub PUSH_Stack
         SPP = SPP + 1
         If SPP > BSize Then SPP = 0
      End If
      X = X1 + 1

      Do
         Do
            Tmp1_Byte = Y
            Tmp_Word  = X
            Tmp_Byte  = LCD_Point( FLayer, Tmp_Word, Tmp1_Byte )
            If Tmp_Word > MaxX Or Tmp1_Byte > MaxY Then Tmp_Byte = 255
            If X <= MaxX And Tmp_Byte = Bkgrnd Then X = X + 1 Else Goto WW2
         Loop
WW2:
         Tmp_Int = L + 2
         If X > Tmp_Int Then
             'LINE (l, y)-(x - 1, y), clr
             Tmp1_Word = L
             Tmp1_Byte = Y
             Tmp2_Word = X - 1
             Tmp2_Byte = Y
             LCD_Line_Draw FLayer, 1, Tmp1_Word, Tmp1_Byte, Tmp2_Word, Tmp2_Byte, FBright
         Else
            Tmp_Int = X - 1
            If L <> Tmp_Int Then
               If L < Tmp_Int Then Step_Int = -1 Else Step_Int = 1
            Else
               Tmp1_Word = L
               Tmp1_Byte = Y
               LCD_Plot FLayer, 1, Tmp1_Word, Tmp1_Byte, FBright
               Goto S_Pixel
            End If
            For F_I = L To Tmp_Int Step Step_Int
               Tmp1_Word = F_I
               Tmp1_Byte = Y
               LCD_Plot FLayer, 1, Tmp1_Word, Tmp1_Byte, FBright
            Next F_I
S_Pixel:

         End If
         Stack_St( S_YY )  = Y
         Stack_St( S_XL ) = L
         Stack_St( S_XR ) = X - 1
         Stack_St( S_DY ) = DY
         Gosub PUSH_Stack
         SPP = SPP + 1

         If SPP > BSize Then SPP = 0
         Tmp_Int = X2 + 1
         If X > Tmp_Int Then
            Stack_St( S_YY )  = Y
            Stack_St( S_XL ) = X2 + 1
            Stack_St( S_XR ) = X - 1
            Stack_St( S_DY ) = -DY
            Gosub PUSH_Stack
            SPP = SPP + 1
            If SPP > BSize Then SPP = 0
         End If

Skip:
         X = X + 1
         Do
            Tmp1_Byte = Y
            Tmp_Word  = X
            Tmp_Byte  = LCD_Point( FLayer, Tmp_Word, Tmp1_Byte )
            If Tmp_Word > MaxX Or Tmp1_Byte > MaxY Then Tmp_Byte = 255
         If X <= X2 And Tmp_Byte <> Bkgrnd Then X = X + 1 Else Goto WW3
         Loop
WW3:
         L = X

      Loop Until X >= X2

   Wend

   Goto End_Fill

PUSH_Stack:

   'CPU belso stack eseten
'   Tmp_Word = SPP * 4
'   Incr Tmp_Word
'   IntStack( Tmp_Word ) = Stack_St( S_YY )  : Incr Tmp_Word
'   IntStack( Tmp_Word ) = Stack_St( S_XL ) : Incr Tmp_Word
'   IntStack( Tmp_Word ) = Stack_St( S_XR ) : Incr Tmp_Word
'   IntStack( Tmp_Word ) = Stack_St( S_DY )
'   Return

   'FPGA-ban a VRAM-ban van a stack
   CPU_Write Reg_Select, Addr_Auto_Inc_Reg
   CPU_Write Reg_Data, 1 ' +1

   Stack_Addr = SPP * 8
   Stack_Addr = Stack_Addr + S_Addr

   Tmp1_Byte = Low( Stack_St( 1 ))
   CPU_Poke 1, Stack_Addr, Tmp1_Byte
   Tmp1_Byte = High( Stack_St( 1 ))
   CPU_Write Reg_Data, Tmp1_Byte

   Tmp1_Byte = Low( Stack_St( 2 ))
   CPU_Write Reg_Data, Tmp1_Byte
   Tmp1_Byte = High( Stack_St( 2 ))
   CPU_Write Reg_Data, Tmp1_Byte

   Tmp1_Byte = Low( Stack_St( 3 ))
   CPU_Write Reg_Data, Tmp1_Byte
   Tmp1_Byte = High( Stack_St( 3 ))
   CPU_Write Reg_Data, Tmp1_Byte

   Tmp1_Byte = Low( Stack_St( 4 ))
   CPU_Write Reg_Data, Tmp1_Byte
   Tmp1_Byte = High( Stack_St( 4 ))
   CPU_Write Reg_Data, Tmp1_Byte

   Return

POP_Stack:

   'CPU belso stack eseten
'   Tmp_Word = SPP2 * 4
'   Incr Tmp_Word
'   Stack_St( S_YY )  = IntStack( Tmp_Word ) : Incr Tmp_Word
'   Stack_St( S_XL ) = IntStack( Tmp_Word ) : Incr Tmp_Word
'   Stack_St( S_XR ) = IntStack( Tmp_Word ) : Incr Tmp_Word
'   Stack_St( S_DY ) = IntStack( Tmp_Word )
'   Return

   'FPGA-ban a VRAM-ban van a stack
   CPU_Write Reg_Select, Addr_Auto_Inc_Reg
   CPU_Write Reg_Data, 1 ' +1

   Stack_Addr = SPP2 * 8
   Stack_Addr = Stack_Addr + S_Addr

   Tmp1_Byte  = CPU_Peek( 1, Stack_Addr )
   Tmp2_Byte  = CPU_Read( Reg_Data )
   Stack_St( 1 ) = Makeint( Tmp1_Byte, Tmp2_Byte )

   Tmp1_Byte  = CPU_Read( Reg_Data )
   Tmp2_Byte  = CPU_Read( Reg_Data )
   Stack_St( 2 ) = Makeint( Tmp1_Byte, Tmp2_Byte )

   Tmp1_Byte  = CPU_Read( Reg_Data )
   Tmp2_Byte  = CPU_Read( Reg_Data )
   Stack_St( 3 ) = Makeint( Tmp1_Byte, Tmp2_Byte )

   Tmp1_Byte  = CPU_Read( Reg_Data )
   Tmp2_Byte  = CPU_Read( Reg_Data )
   Stack_St( 4 ) = Makeint( Tmp1_Byte, Tmp2_Byte )

   Return

End_Fill:
   CPU_Write Reg_Select, Addr_Auto_Inc_Reg
   CPU_Write Reg_Data, 0 ' +0

End Sub



'******************************************
'**  Torli a teljes 128kByte-os RAM-ot.  **
'******************************************

Sub Clear_RAM
   Local II As Word
   Cpu_write Reg_select , ADDR_AUTO_INC_reg
   Cpu_write Reg_data , &B00000001
   CPU_Poke 0 , 0 , 0
   'A teljes 128 kByte torlese
   For II = 0 To 65535
      CPU_Write Reg_Data , 0
      CPU_Write Reg_Data , 0
   Next II
End Sub

Sub Check_Keyboard
 '*****************************************
 '** CD4021-es bemeneti port beolvass  ***
 '*****************************************
 '3db CD4094 van sorbakotve es osszesen 24
 'bit lesz beolvasva
 CD4021_Strobe = 1
 NOP, NOP, NOP, NOP, NOP, NOP
 CD4021_Strobe = 0
 Shiftin CD4021_Q8 , CD4021_Clk , Port4021, 2, 24
End Sub



'******************************************
'** A Szoveg string valtozoban levo szo- **
'** veget irja ki a SX, SY koordinataktol**
'** kezdodoen, a megatott attributummal. **
'**     A Szoveg valtozo globalis!       **
'******************************************
Sub LCD_SPrint ( Byval SX As Byte, Byval SY As Byte,  Byval Text_Attr As Byte )
   Local TMP1 As Word
   Local TMP2 As Word
   Local TMP3 As Word
   Local PP   As Byte ' String pointer
   Local SS   As Byte ' String code

   'Ha ures a tring, akkor nem csinal semmit
   If Szoveg ="" Then Exit Sub

   'Lapozo bitek beallitasa
   CPU_Write Reg_Select , Text_Start_H_Reg
   PP = CPU_Read ( Reg_Data )
   If PP.7 = 0 Then VRAM_A17_A16 = 0 Else VRAM_A17_A16 = 1

   'TMP3 -ba a Text Layer kezdocime
   CPU_Write Reg_Select , Text_Start_L_Reg
   SS = CPU_Read ( Reg_Data )
   TMP3 = PP
   TMP3 = TMP3 * 256
   TMP3 = TMP3 + SS
   TMP3 = TMP3 * 2

   PP = 1               'String pointer kezdoerteke
   TMP2 = Len( Szoveg ) 'TMP2 -be a szoveg hossza

   'A szoveg elso karakterenek a relativ kezdocimenek kiszamitasa
   VRAM = SY * 80
   VRAM = VRAM + SX
   VRAM = VRAM + SX
   TMP1 = VRAM          'Szoveg elso karakterenek a relativ kezdocime
   TMP2 = Len( Szoveg ) 'Szoveg hosszanak a meghatarozasa

   'A szoveg elso karakterenek abszolut cime a video RAM-ban
   VRAM = TMP3 + TMP1

   'A szoveg hosszanak megfelelo ciklus
   For TMP3 = 1 To TMP2
      'Video RAM cimzes beallitas
      Set_Vram_Addr
      'A PP pointernek megfelelo karakter kivalasztasa
      Karakter = Mid( Szoveg, PP, 1 )
      'ASCII kodda alakitas
      SS = Asc( Karakter )
      'Beiras a video RAM-ba
      CPU_Write Reg_Data, SS
      'Cim novelese az attributum beirashoz
      'ha be lenne kapcsolva az automatikus cim noveles, akkor nem kellene,
      'de igy biytosan nem felejtodik el.
      Incr VRAM
      'A vodeo RAM cimzes beallitas
      Set_Vram_Addr
      'A karakter attributum beirasa a RAM-ba
      CPU_Write Reg_Data, Text_Attr
      'Cim novelese
      Incr VRAM
      'A PP pointer novelese
      Incr PP
   Next TMP3
End Sub



Sub LCD_Circle_Draw ( Byval C_Layer As Byte , Byval Write_Mode As Byte,  Byval Center_X As Word , Byval Center_Y As Byte , Byval Radius As Word, Byval Deg as byte, Byval C_Bright As Byte )
   Local TMP As Byte

   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'A felso 4 bit a kor rajzolas funkciot valasztja ki,
   Write_Mode = &H0F And Write_Mode
   'az also 4 bit pedig az irasi modot
   TMP = &H20 Or Write_Mode
   'GPU funkcio regiszter beallitasa
   CPU_Write Reg_Select , GPU_Function_Reg
   CPU_Write Reg_Data , TMP

   'A kozeppont X koordinata beallitas
   TMP = High(Center_X)
   CPU_Write Reg_Data , TMP 'X_H
   TMP = Low(Center_X)
   CPU_Write Reg_Data , TMP 'X_L

   'A kozeppont Y koordinata beallitas
   CPU_Write Reg_Data , Center_Y 'Y

   'A kor sugaranak beallitasa
   TMP = High(Radius)
   CPU_Write Reg_Data , TMP 'X1_H
   TMP = Low(Radius)
   CPU_Write Reg_Data , TMP 'X1_L

   'Az 1/8 korivek engedelyezese
   CPU_Write Reg_Data , Deg 'Y1

   'A 5,4,3 bitekbe a grafikus lap vagy sprite ahova rajzolni akarunk
   Shift C_Layer , Left , 3
   C_Layer = &B00111000 And C_Layer
   'A tobbi bit-be a fenyero es a sprite-tal kapcsolatos bitek valamint a START jel
   TMP = &B11000111 And C_Bright
   TMP = TMP Or C_Layer
   'CIRCLE_Start regiszter beallitasa
   CPU_Write Reg_Data , TMP
End Sub

Sub Lcd_line_draw( Byval L_Layer As Byte , Byval Write_Mode As Byte,  Byval L_X As Word , Byval L_Y As Byte , Byval L_X1 As Word , Byval L_Y1 As Byte , Byval L_Bright As Byte )
   Local TMP As Byte

   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'A felso 4 bit a vonal rajzolas funkciot valasztja ki,
   Write_Mode = &H1F And Write_Mode
   'az also 4 bit pedig az irasi modot
   TMP = &H10 Or Write_Mode
   'GPU funkcio regiszter beallitasa
   CPU_Write Reg_Select , GPU_Function_Reg
   CPU_Write Reg_Data , TMP

   'Kezdopont X koordinata beallitasa
   TMP = High(L_X)
   CPU_Write Reg_Data , TMP ' X_H
   TMP = Low(L_X)
   CPU_Write Reg_Data , TMP ' X_L
   'Kezdopont Y koordinata beallitasa
   CPU_Write Reg_Data , L_Y  ' Y

   'Vegpont X koordinata beallitasa
   TMP = High(L_X1)
   CPU_Write Reg_Data , TMP ' X1_H
   TMP = Low(L_X1)
   CPU_Write Reg_Data , TMP ' X1_L
   'Vegpont Y koordinata beallitasa
   CPU_Write Reg_Data , L_Y1

   'A 5,4,3 bitekbe a grafikus lap vagy sprite ahova rajzolni akarunk
   Shift L_Layer , Left , 3
   L_Layer = &B00111000 And L_Layer
   'A tobbi bit-be a fenyero es a sprite-tal kapcsolatos bitek valamint a START jel
   TMP = &B11000111 And L_Bright
   TMP = TMP Or L_Layer
   'LINE_Start regiszter beallitasa
   CPU_Write Reg_Data , TMP
End Sub

Sub Lcd_Count_Line_Draw( Byval L_Layer As Byte, Byval L_X As Word , Byval L_Y As Byte, Byval L_Bright As Byte )
   Local TMP As Byte

   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'Vegpont X koordinata beallitasa
   CPU_Write Reg_Select , X1_H_Reg
   TMP = High(L_X)
   CPU_Write Reg_Data , TMP
   TMP = Low(L_X)
   CPU_Write Reg_Data , TMP
   'Vegpont Y koordinata beallitasa
   CPU_Write Reg_Data , L_Y

   'A 5,4,3 bitekbe a grafikus lap vagy sprite ahova rajzolni akarunk
   Shift L_Layer , Left , 3
   L_Layer = &B00111000 And L_Layer
   'A tobbi bit-be a fenyero es a sprite-tal kapcsolatos bitek valamint a START jel
   TMP = &B11000111 And L_Bright
   TMP = TMP Or L_Layer
   'LINE_Start regiszter beallitasa
   CPU_Write Reg_Data , TMP
End Sub

Sub Lcd_Plot( Byval P_Layer As Byte , Byval Write_Mode As Byte, Byval P_X As Word , Byval P_Y As Byte , Byval P_Bright As Byte )
   Local TMP As Byte

   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'A felso 4 bit a pont rajzolas funkciot valasztja ki,
   'az also 4 bit pedig az irasi modot
   Write_Mode = &H0F And Write_Mode
   'GPU funkcio regiszter beallitasa
   CPU_Write Reg_Select , GPU_Function_Reg
   CPU_Write Reg_Data , Write_Mode

   TMP = High(P_X)
   CPU_Write Reg_Data , TMP
   TMP = Low(P_x)
   CPU_Write Reg_Data , TMP
   CPU_Write Reg_Data , P_Y

   'A 5,4,3 bitekbe a grafikus lap vagy sprite ahova rajzolni akarunk
   Shift P_Layer , Left , 3
   P_Layer = &B00111000 And P_Layer
   'A tobbi bit-be a fenyero es a sprite-tal kapcsolatos bitek valamint a START jel
   TMP = &B11000111 And P_Bright
   TMP = TMP Or P_Layer
   'Pixel_Start regiszter beallitasa
   CPU_Write Reg_Data , TMP
End Sub

Function Lcd_Point( Byval P_Layer As Byte , Byval P_X As Word , Byval P_Y As Byte ) As Byte
   Local TMP As Byte

   'Varakozas egy amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'GPU funkcio regiszter beallitasa
   'Csak 0 erteket kell beallitani, mert  POINT funkcional az also
   '4 bit-nek nincs jelentosege es a funkcio kivalasztasahoz pedig
   'a felso 4 bit-be 0 kell
   CPU_Write Reg_Select , GPU_Function_Reg
   CPU_Write Reg_Data , 0

   'A pont X koordinata beallitasa
   TMP = High(P_X)
   CPU_Write Reg_Data , TMP
   TMP = Low(P_X)
   CPU_Write Reg_Data , TMP
   'A pont Y koordinata beallitas
   CPU_Write Reg_Data , P_Y
   'POINT funkcio inditas
   P_Layer = &B00000111 And P_Layer
   Shift P_Layer , Left , 3
   TMP = 128 Or P_Layer
   CPU_Write Reg_Data , TMP

   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   'A pont fenyerejenek kiolvasasa
   CPU_Write Reg_Select , Plot_Data_Reg
   TMP = CPU_Read( Reg_Data )
   Lcd_Point = TMP AND &B00000111
End Function



'A Vram valtozonak megfelelo cimet beirja az FPGA RAM cimregiszterebe
Sub Set_VRAM_Addr
   Local VRAM_hi As Byte
   Local VRAM_lo As Byte
   Local A17_A16 As Byte
   VRAM_Hi = High( VRAM )
   VRAM_Lo = Low( VRAM )
   A17_A16 = VRAM_A17_A16

   CPU_Write Reg_Select , 0
   CPU_Write Reg_Data , VRAM_A17_A16
   CPU_Write Reg_Data , VRAM_Hi
   CPU_Write Reg_Data , VRAM_Lo
End Sub

'A Vram-nak megfelelo cimre ir
Sub CPU_Poke( Byval A17_A16 As Byte , Byval Address As Word , Byval Adat As Byte )
   VRAM = Address
   VRAM_A17_A16 = A17_A16
   Set_VRAM_Addr
   CPU_Write Reg_Data , Adat
End Sub

'A Vram-nak megfelelo cimrol olvas
Function CPU_Peek( Byval A17_A16 As Byte , Byval Address As Word ) As Byte
   VRAM = Address
   VRAM_A17_A16 = A17_A16
   Set_VRAM_Addr
   CPU_Peek = CPU_Read( Reg_Data )
End Function


'Az kivalasztott FPGA regiszter irasa
Sub CPU_Write( Byval RS As Byte , Byval Adat As Byte)
   Config Portc = Output
   CPU_RS = RS.0
   CPU_Write_Data = Adat
   CPU_RD = 1
   CPU_WR = 0
   CPU_WR = 1
   Config Portc = Input
End Sub

'Az kivalasztott FPGA regiszter olvasasa
Function CPU_Read( Byval RS As Byte) As Byte
   Config Portc = Input
   CPU_RS = RS.0
   CPU_RD = 0
   CPU_WR = 1
   CPU_Read = PINC 'Cpu_read_data
   CPU_RD = 1
End Function

Sub LCD_CLS ( Byval Lx As Byte )
   Local L As byte  ' Cim also byte
   Local H As Byte  ' Cim felso byte
   Local LM As Byte ' Layer mod 0 vagy 1
   Local II As Word ' Ciklus szamlalo
   Local LHossz As Word ' A lap hossza

   If Lx > 8 Then Exit Sub

   CPU_Write Reg_Select, Addr_Auto_Inc_Reg
   CPU_Write Reg_Data, 1 ' +1

   If Lx = Layer0 Then
      CPU_Write Reg_Select , Layer0_Mode_Reg
      LM = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer0_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer0_Start_L_Reg
   End If
   If Lx = Layer1 Then
      CPU_Write Reg_Select , Layer1_Mode_Reg
      LM = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer1_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer1_Start_L_Reg
   End If
   If Lx = Layer2 Then
      CPU_Write Reg_Select , Layer2_Mode_Reg
      LM = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer2_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer2_Start_L_Reg
   End If
   If Lx = Layer3 Then
      CPU_Write Reg_Select , Layer3_Mode_Reg
      LM = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer3_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Layer3_Start_L_Reg
   End If
   If Lx = LayerX Then
      CPU_Write Reg_Select , LayerX_Mode_Reg
      LM = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , LayerX_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , LayerX_Start_L_Reg
   End If

   LM = LM And &B00000001

   If Lx = Text_Layer Then
      LM = 2 ' 2400 a hossz
      CPU_Write Reg_Select , Text_Start_H_Reg
      H = CPU_Read ( Reg_Data )
      CPU_Write Reg_Select , Text_Start_L_Reg
   End If
   L = CPU_Read ( Reg_Data )

   'A17, A16 beallitas
   If H.7 = 0 Then VRAM_A17_A16 = 0 Else VRAM_A17_A16 = 1

   VRAM = H
   VRAM = VRAM * 256
   VRAM = VRAM + L
   VRAM = VRAM * 2

   If Lx = Sprite0 Then
      VRAM_A17_A16 = 2 ' A17=1 FPGA belso RAM cimzes
      LM = 3    ' 2048 a hossz
      VRAM = &H5000 'Sprite0 cime
   End If
   If Lx = Sprite1 Then
      VRAM_A17_A16 = 2 ' A17=1 FPGA belso RAM cimzes
      LM = 3    ' 2048 a hossz
      VRAM = &H5000 'Sprite1 cime
   End If
   If Lx = Sprite2 Then
      VRAM_A17_A16 = 2 ' A17=1 FPGA belso RAM cimzes
      LM = 3    ' 2048 a hossz
      VRAM = &H6000 'Sprite2 cime
   End If

   Set_VRAM_Addr ' Videoram cimregiszter beallitasa

   'Az adott layer torlese
   If LM = 0 Then LHossz = 9600
   If LM = 1 Then LHossz = 19200
   If LM = 2 Then LHossz = 1200
   If LM = 3 Then LHossz = 2048
   If Lx = Text_Layer Then
      For II = 1 To LHossz
         CPU_Write Reg_Data, 0
         CPU_Write Reg_Data, &B00000110
      Next II
   Else
      For II = 1 To LHossz
         CPU_Write Reg_Data, 0
      Next II
   End If
End Sub

'Beallitja a kivalasztott sprite koordinatait
Sub LCD_Set_Sprite_XY ( Byval Sprite_Num As Byte, Byval Sprite_X As Word, Byval Sprite_Y As Byte  )
   Local TMP As Byte
   If Sprite_Num = 5 Then CPU_Write Reg_Select , Sprite0_X_H_Reg
   If Sprite_Num = 6 Then CPU_Write Reg_Select , Sprite1_X_H_Reg
   If Sprite_Num = 7 Then CPU_Write Reg_Select , Sprite2_X_H_Reg

   TMP.0 = Sprite_X.8
   CPU_Write Reg_Data, TMP
   TMP = Low( Sprite_X )
   CPU_Write Reg_Data, TMP
   CPU_Write Reg_Data, Sprite_Y
End Sub

Sub LCD_Sprite_Enable ( Byval Sprite_Num As Byte )
   Local TMP As Byte
   CPU_Write Reg_Select , Sprite_Enable_Reg
   TMP = CPU_Read( Reg_Data )
   If Sprite_Num = 5 Then TMP.0 = 1
   If Sprite_Num = 6 Then TMP.2 = 1
   If Sprite_Num = 7 Then TMP.4 = 1
   CPU_Write Reg_Data, TMP
End Sub

Sub LCD_Sprite_Disable ( Byval Sprite_Num As Byte )
   Local TMP As Byte
   CPU_Write Reg_Select , Sprite_Enable_Reg
   TMP = CPU_Read( Reg_Data )
   If Sprite_Num = 5 Then TMP.0 = 0
   If Sprite_Num = 6 Then TMP.2 = 0
   If Sprite_Num = 7 Then TMP.4 = 0
   CPU_Write Reg_Data, TMP
End Sub

Sub LCD_Set_Block_XY ( Byval W_Mode As Byte, Byval S_X As Word, Byval S_Y As Byte, Byval T_X As Word, Byval T_Y As Byte )
   Local TMP As Byte

  'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   W_Mode = &B00001111 And W_Mode
   TMP = &B00110000 Or W_Mode
   CPU_Write Reg_Select, GPU_Function_Reg
   CPU_Write Reg_Data, TMP
   TMP = High( S_X )
   CPU_Write Reg_Data, TMP 'X_H_Reg
   TMP = Low( S_X )
   CPU_Write Reg_Data, TMP 'X_L_Reg
   CPU_Write Reg_Data, S_Y 'Y_Reg
   TMP = High( T_X )
   CPU_Write Reg_Data, TMP 'X1_H_Reg
   TMP = Low( T_X )
   CPU_Write Reg_Data, TMP 'X1_L_Reg
   CPU_Write Reg_Data, T_Y 'Y1_Reg
End Sub

Sub LCD_Block ( Byval B_Mode As Byte, Byval B_Width As Word, Byval B_Height As Byte, Byval S_Layer As Byte, Byval T_Layer As Byte, Byval B_Bright As Byte )
   Local TMP As Byte
  'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0

   CPU_Write Reg_Select, Block_Mode_Reg
   CPU_Write Reg_Data, B_Mode     'Block_Mode_reg
   TMP.0 = B_Width.8
   CPU_Write Reg_Data, TMP        'Block_Width_H_Reg
   TMP = Low( B_Width )
   CPU_Write Reg_Data, TMP        'Block_Width_L_Reg
   CPU_Write Reg_Data, B_Height   'Block_Height_Reg
   S_Layer = &B00000111 And S_Layer
   T_Layer = &B00000111 And T_Layer
   Rotate T_Layer, Left, 3
   B_Bright = &B00000011 And B_Bright
   Rotate B_Bright, Left, 6
   TMP = S_Layer + T_Layer
   TMP = TMP + B_Bright
   CPU_Write Reg_Data, TMP        'Block_Start
   'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0
End Sub

Sub LCD_Scroll_GLayer ( Byval S_Layer As Byte, Byval S_Dir As Byte, Byval S_Mode As Byte, Byval S_Step As Word )
   Local TMP As Byte
   Local Tmp_Word As Word

   If S_Layer > 3 Then Exit Sub
   If S_Step  = 0 Then Exit Sub
  'Varakozas amig a GPU szabad lessz
   Do
   Loop Until CPU_Busy = 0
   'LayerX grafikus modot ugyanugy be kell allitani mint ahogy a
   'gorgetni kivant lap van beallitva
   If S_Layer = Layer0 Then  CPU_Write Reg_Select, Layer0_Mode_Reg
   If S_Layer = Layer1 Then  CPU_Write Reg_Select, Layer1_Mode_Reg
   If S_Layer = Layer2 Then  CPU_Write Reg_Select, Layer2_Mode_Reg
   If S_Layer = Layer3 Then  CPU_Write Reg_Select, Layer3_Mode_Reg
   TMP = CPU_Read ( Reg_Data )
   CPU_Write Reg_Select, LayerX_Mode_Reg
   CPU_Write Reg_Data, TMP

   'Ha fel vagy lefele gorgetunk, akkor csak 240 sorig van ertelme
   If S_Dir = Dir_Up Or S_Dir = Dir_Down Then
      If S_Step > 240 Then S_Step = 240
   End If

   'Ha korbeforgatas funkcio kell, akkor a kigorgetett reszt elmentjuk
   'a LayerX-re es majd visszamasoljuk a vegen
   If S_Mode = Roll Then
      If S_Dir = Dir_Right Then
         TMP_Word = 320 - S_Step
         LCD_Set_Block_XY 1, TMP_Word, 0, 0, 0 'Overwrite
         LCD_Block 1, S_Step, 240, S_Layer, LayerX, 0 'MOVE
      End If
      If S_Dir = Dir_Left Then
         LCD_Set_Block_XY 1, 0, 0, 0, 0 'Overwrite
         LCD_Block 1, S_Step, 240, S_Layer, LayerX, 0 'MOVE
      End If
      If S_Dir = Dir_Up Then
         LCD_Set_Block_XY 1, 0, 0, 0, 0 'Overwrite
         TMP = S_Step
         LCD_Block 1, 320, TMP, S_Layer, LayerX, 0 'MOVE
      End If
      If S_Dir = Dir_Down Then
         TMP = 240 - S_Step
         LCD_Set_Block_XY 1, 0, TMP, 0, 0 'Overwrite
         TMP = S_Step
         LCD_Block 1, 320, TMP, S_Layer, LayerX, 0 'MOVE
      End If
   End If

   If S_Dir = Dir_Right Then
      LCD_Set_Block_XY 1, 0, 0, S_Step, 0 'Overwrite
      LCD_Block 0, 320, 240, S_Layer, S_Layer, 0 'COPY
      'Mivel csak Copy funkcio volt a nagyobb sebesseg erdekeben, ezert
      'a bal oldali reszt torolni kell
      If S_Mode = Scroll Then
         LCD_Set_Block_XY  1, 0, 0, 0, 0 'Overwrite
         LCD_Block 2, S_Step, 240, S_Layer, S_Layer, 0 'FILL
      End If
   End If
   If S_Dir = Dir_Left Then
      LCD_Set_Block_XY 1, S_Step, 0, 0, 0 'Overwrite
      LCD_Block 0, 320, 240, S_Layer, S_Layer, 0 'COPY
      'Mivel csak Copy funkcio volt a nagyobb sebesseg erdekeben, ezert
      'a jobb oldali reszt torolni kell
      If S_Mode = Scroll Then
         TMP_Word = 319 - S_Step
         LCD_Set_Block_XY  1, TMP_Word, 239, TMP_Word, 239 'Overwrite
         LCD_Block 2, S_Step, 240, S_Layer, S_Layer, 0 'FILL
      End If
   End If

   If S_Dir = Dir_Up Then
      TMP = Low( S_Step )
      LCD_Set_Block_XY 1, 0, TMP, 0, 0
      LCD_Block 0, 320, 240, S_Layer, S_Layer, 0
      'Mivel csak Copy funkcio volt a nagyobb sebesseg erdekeben, ezert
      'az also reszt reszt torolni kell
      If S_Mode = Scroll Then
         LCD_Set_Block_XY  1, 0, 239, 0, 239 'Overwrite
         LCD_Block 2, 320, TMP, S_Layer, S_Layer, 0 'FILL
      End If
   End If

   If S_Dir = Dir_Down Then
      TMP = Low( S_Step )
      LCD_Set_Block_XY 1, 0, 0, 0, TMP
      LCD_Block 0, 320, 240, S_Layer, S_Layer, 0
      'Mivel csak Copy funkcio volt a nagyobb sebesseg erdekeben, ezert
      'a felso reszt torolni kell
      If S_Mode = Scroll Then
         LCD_Set_Block_XY  1, 0, 0, 0, 0 'Overwrite
         LCD_Block 2, 320, TMP, S_Layer, S_Layer, 0 'FILL
      End If
   End If

   'A LayerX -re elmentett reszek visszamasolasa a megfelelo helyre ha
   'a korbeforgatas funkcio volt
   If S_Mode = Roll Then
      If S_Dir = Dir_Right Then
         LCD_Set_Block_XY 1, 0, 0, 0, 0 'Overwrite
         LCD_Block 0, S_Step, 239, LayerX, S_Layer, 0 'COPY
      End If
      If S_Dir = Dir_Left Then
         TMP_Word = 320 - S_Step
         LCD_Set_Block_XY 1, 0, 0, TMP_Word, 0 'Overwrite
         LCD_Block 0, S_Step, 240, LayerX, S_Layer, 0 'COPY
      End If
      If S_Dir = Dir_Up Then
         TMP = 240 - Low( S_Step )
         LCD_Set_Block_XY 1, 0, 0, 0, TMP 'Overwrite
         TMP = S_Step
         LCD_Block 0, 320, TMP, LayerX, S_Layer, 0 'COPY
      End If
      If S_Dir = Dir_Down Then
         LCD_Set_Block_XY 1, 0, 0, 0, 0 'Overwrite
         TMP = Low( S_Step )
         LCD_Block 0, 320, TMP, LayerX, S_Layer, 0 'COPY
      End If
   End If

End Sub