Sub Scope_Teszt
   Local Trigger_en    As Byte
   Local Trigger_addr  As Word
   Local Trigger_Pont  As Byte

   Local Start_Bit     As Byte
   Local I             As Byte
   Local X             As Byte
   Local II            As Word
   Local JJ            As Word
   Local Y             As Byte

   Local Lcd_x         As Word
   Local Lcd_y         As Byte
   Local Lcd_x1        As Word
   Local Lcd_y1        As Byte

   Local Sp_xpos       As Word
   Local Sp_ypos       As Byte
   Local WW            As Word



   'Ram torlese
   Clear_Ram


   'Layer mode reg
   'DEFAULT-> x  x  0  0  0  1  1  1    R/W
            'b7 b6 b5 b4 b3 b2 b1 b0
            ' |  |  |  |  |  |  |  |
            ' |  |  |  |  |  |  |  \-> layer_bright[0]
            ' |  |  |  |  |  |  \----> layer_bright[1]
            ' |  |  |  |  |  \-------> layer_mode       0=1bit/pixel 1=2bit/pixel
            ' |  |  |  |  \----------> layer_blink_en   0=tiltva, 1=villogas engedelyezve
            ' |  |  |  \-------------> layer_blink_inv  0=normal, 1=ellenutemu villogas
            ' |  |  \----------------> layer_mask_en    0=normal, 1=kitakar ( Layer0-nal nincs )
            ' |  \-------------------> nc
            ' \----------------------> nc

   'Layer0 Trigger szint megjelenitese
   Cpu_Write Reg_Select , Layer0_Mode_Reg
   Cpu_Write Reg_Data , &B00000111 '2 bit/pixel mod

   'Layer1 Digitalizalt adat megjelenitese
   Cpu_Write Reg_Select , Layer1_Mode_Reg
   Cpu_Write Reg_Data , &B00000111 '2 bit/pixel mod

   'Layer2 raszterhalo megjelenitese
   Cpu_Write Reg_Select , Layer2_Mode_Reg
   Cpu_Write Reg_Data , &B00000111 '2 bit/pixel mod

   'Layer3 nincs hasznalva
   Cpu_Write Reg_Select , Layer3_Mode_Reg
   Cpu_Write Reg_Data , &B00000111 '2 bit/pixel mod


   'Text layer beallitas
   Cpu_Write Reg_Select , Text_mode_reg
   Cpu_Write Reg_Data , &B00000000
         'b7 b6 b5 b4 b3 b2 b1 b0   R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> char_gen_size 0=8 1=12
         ' |  |  |  |  |  |  \----> char_size[0]
         ' |  |  |  |  |  \-------> char_size[1]
         ' |  |  |  |  \----------> char_size[2]
         ' |  |  |  \-------------> blink_rate[0]
         ' |  |  \----------------> blink_rate[1]
         ' |  \-------------------> blink_rate[2]
         ' \----------------------> blink_rate[3]

   'Sprite megjelenites tiltas
   Cpu_Write Reg_Select , Sprite_enable_reg
   Cpu_Write Reg_Data , &B00000000

   'Az osszes layer engedelyezese
   Cpu_Write Reg_Select , Lcd_enable_reg
   Cpu_Write Reg_Data , &B10011111

   'Layer2 scope raszterhalo kirajzolas
   For II = 0 To 200 Step 20
      LCD_Line_Draw 2, 1, II, 79, II, 239, 1
   Next I
   For I = 239 To 79 Step -20
      LCD_Line_Draw 2, 1, 0, i, 199, i, 1
   Next I

   For II = 10 To 190 Step 20
      LCD_Line_Draw 2, 1, II, 158, II, 160, 1
   Next I
   For I = 230 To 85 Step -20
      LCD_Line_Draw 2, 1, 99, i, 101, i, 1
   Next I


   'Poti mode beallitasa a nyak kialakitasa miatt nem mindegyik
   'egyforma.
   Cpu_Write Reg_Select , ENCODER_MODE_Reg
   Cpu_Write Reg_Data , &B10110000
   'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
      'b7 b6 b5 b4 b3 b2 b1 b0    R/W
      ' |  |  |  |  |  |  |  |
      ' |  |  |  |  |  |  |  \->  ENC0_MODE  R/W  \
      ' |  |  |  |  |  |  \---->  ENC1_MODE  R/W   \__ 0 = Overflow enable
      ' |  |  |  |  |  \------->  ENC2_MODE  R/W   /   1 = Overflow disable
      ' |  |  |  |  \---------->  ENC3_MODE  R/W  /
      ' |  |  |  \------------->  ENC0_DIR   R/W  \
      ' |  |  \---------------->  ENC1_DIR   R/W   \__ 0 = POSITION INCREMENT
      ' |  \------------------->  ENC2_DIR   R/W   /   1 = POSITION DECREMENT
      ' \---------------------->  ENC3_DIR   R/W  /

   Cpu_Write Reg_Select , ENCODER_TYPE_Reg
   Cpu_Write Reg_Data , &B00001111  'EC85 enkoder mod beallitasa

 'enkodereket alap allasba rakja
   Cpu_Write Reg_Select , ENCODER0_POS_Reg
   CPU_Write  Reg_Data, 0
   Cpu_Write Reg_Select , ENCODER1_POS_Reg
   CPU_Write  Reg_Data, 0
   Cpu_Write Reg_Select , ENCODER2_POS_Reg
   CPU_Write  Reg_Data, 0
   Cpu_Write Reg_Select , ENCODER3_POS_Reg
   CPU_Write  Reg_Data, 0




   'FPGA PORT2.0 PWM beallitasa hogy az A/D bemeneten legyen valami jel.
   'Szinkron nelkul sem fog futni a jel csak nem lesz trigger pozicioba,
   'mert az alap orajel ugyanaz a forras.
   '
   'PORT2 OUT
   Cpu_Write Reg_Select , PORT2_OUT_Reg ' PORT2 OUT
   Cpu_Write Reg_Data , &B00000001 'PORT2.0 kimenet
   'PORT2 DIR
   Cpu_Write Reg_Select , PORT2_DIR_Reg ' PORT2 DIR
   Cpu_Write Reg_Data , &B00000001 'PORT2.0 kimenet
   'PORT2 ALT
   Cpu_Write Reg_Select , PORT2_ALT_Reg 'PORT2 ALT
   Cpu_Write Reg_Data , &B00000001      'PORT2.0 alternativ funkcio
   'PWM8_0_IN
   Cpu_write Reg_Select , PWM0_8_Reg '8 bit-es PWM0
   Cpu_Write Reg_Data , 100          'Kitoltesi tenyezo beallitasa

   'PORT1 bemenetnek allitva az A/D csatlakozasahoz
   'PORT2 OUT
   Cpu_Write Reg_Select , PORT1_OUT_Reg ' PORT1 OUT
   Cpu_Write Reg_Data , &B00000000 'PORT1 bemenet


do

   'SW3 vissza a fomenube
   If SW3 = 0 Then Exit Sub


  ' Do

      'Trigger level beallitasa az ENCODER3 erteketol fuggoen
      Cpu_Write Reg_Select , ENCODER3_POS_Reg
      x = CPU_Read( Reg_Data )
      Cpu_Write Reg_Select , TRIGGER_LEVEL_Reg
      Cpu_Write Reg_Data , x
      Szoveg = "Trigger level= " + str( x ) + "   "
      Lcd_Sprint 0, 2, 6

      'Trigger szint kijelzese egy vonallal Layer0-n
      'A reszterhalon belul kis fenyerovel, a jobb szelen pedig ami
      'tulnyulik, azt max fenyerovel.
      'Nem tul elegans, mert mindenkepp ujra rajzolom akkor is ha nem valtozik,
      'de igy egyszerubb
      x= 239 - x
      Trigger_Pont = x
      'Regi vonal torles
      LCD_Line_Draw 0, 1, 0, Sp_Ypos, 205, Sp_Ypos, 0
      'Uj kirajzolas
      LCD_Line_Draw 0, 1, 0, x, 200, x, 2
      LCD_Line_Draw 0, 1, 201, x, 205, x, 3
      Sp_Ypos = x



      'PORT1 ADC in
      Cpu_Write Reg_Select , PORT1_IN_Reg
      x = CPU_Read( Reg_Data )
      Szoveg = "ADC= " + str( x ) + "   "
      Lcd_Sprint 0, 6, 6


      'Idoalap beallitasa az ENCODER2 erteketol fuggoen, de csak a
      'legalso byte valtozik. Probahoz eleg ez is
      Cpu_Write Reg_select , ENCODER2_POS_Reg
      x = CPU_Read( Reg_Data )
      Cpu_Write Reg_Select , TIME_DIV_2_Reg
      Cpu_Write Reg_Data , &B00000000
      Cpu_Write Reg_Select , TIME_DIV_1_Reg
      Cpu_Write Reg_Data , &B00000000
      Cpu_Write Reg_Select , TIME_DIV_0_Reg
      Cpu_Write Reg_Data , x
      Szoveg = "Time Div= " + str( x ) + "   "
      Lcd_Sprint 0, 1, 6

      'Trigger mode beallitasa az ENCODER1 erteketol fuggoen valtozik
      Cpu_Write Reg_Select , ENCODER1_POS_Reg
      x = CPU_Read( Reg_Data )
      Cpu_Write Reg_Select , TRIGGER_Reg
      Cpu_Write Reg_Data , x
      'DEFAULT-> 0  0  0  0  0  0  0  0   R/W
         'b7 b6 b5 b4 b3 b2 b1 b0    R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> TRIGGER_POL  R/W  0 = "L"    1 = "H"
         ' |  |  |  |  |  |  \----> TRIGGER_MODE R/W  0 = Level  1 = Edge
         ' |  |  |  |  |  \-------> EXT_TRIGGER  R/W  0 = Int.   1 = Ext.
         ' |  |  |  |  \----------> PEAK_MODE    R/W  0 = Normal 1 = Peak detect
         ' |  |  |  \-------------> HYST[0] \
         ' |  |  \----------------> HYST[1]  \ __ Hiszterezis beallitas
         ' |  \-------------------> HYST[2]  /
         ' \----------------------> HYST[3] /
      Szoveg = "Trigger mode= " + bin( x )
      Lcd_Sprint 0, 3, 6




      'Azert hogy egyszeru legyen a max. sample 200 pontra beallitva
      Cpu_Write Reg_Select , SAMPLE_LEN_H_Reg
      Cpu_Write Reg_Data , 0
      Cpu_Write Reg_Select , SAMPLE_LEN_L_Reg
      Cpu_Write Reg_Data , 200




      'Trigger_Reg
         'b7 b6 b5 b4 b3 b2 b1 b0   R/W
         ' |  |  |  |  |  |  |  |
         ' |  |  |  |  |  |  |  \-> Trigger_En     W     Start          R
         ' |  |  |  |  |  |  \----> Sample_Ct_En   W     Sample_Gate    R
         ' |  |  |  |  |  \-------> Write_En       W     Write_Gate     R
         ' |  |  |  |  \----------> Write_Mode     R/W
         ' |  |  |  \-------------> Scope_Stop     R/W
         ' |  |  \----------------> Dig_Mode       R/W
         ' |  \-------------------> Scope_IRQ_En   R/W
         ' \----------------------> Scope_IRQ      R
         '

      Szoveg = "Trigg_En"
      Lcd_Sprint 31, 4, 6
      If Sw4 = 0 Then
         'Trigger_En bit 1-be irasa
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         x = CPU_Read( Reg_data ) AND &B11111000
         x.0 = 1
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , x
      End If

      Szoveg = "Sample_Ct"
      Lcd_Sprint 30, 9, 6
      If Sw5 = 0 Then
         'Sample_Ct_En 1-be irasa
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         x = CPU_Read( Reg_data )  AND &B11111000
         x.1 = 1
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , x
      End If

      Szoveg = "Write_En"
      Lcd_Sprint 31, 15, 6
      If Sw6 = 0 Then
         'Write_En 1-be irasa
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         x = CPU_Read( Reg_data )  AND &B11111000
         x.2 = 1
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , x
      End If

      Szoveg = "Write_mode"
      Lcd_Sprint 29, 20, 6
      Szoveg = "4 or 1 byte"
      Lcd_Sprint 29, 21, 6
      If Sw7 = 0 Then
         '1 byte-os iras engedelyezese
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         x = CPU_Read( Reg_data )
         x.3 = 1
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , x
      End If

      Szoveg = "Stop"
      Lcd_Sprint 35, 25, 6
      If Sw8 = 0 Then
         'Mindent alaphelyzetbe allit es leallitja a mintatarolast is
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , &B00010000
         Start_Bit = 0
      End If



      Szoveg = "SW14->"
      Lcd_Sprint 0, 8, &B00100110
      Szoveg = "Auto trigger start"
      Lcd_Sprint 6, 8, 6
      'Auto trigger beallitasa az SW14 lenyomasara.
      If Sw14 = 0 Then Start_Bit = 1
      Cpu_write Reg_select , SCOPE_STATUS_Reg
      x = CPU_Read( Reg_data )
      If Start_Bit = 1 And x.1 = 0 Then
         Trigger_en = 1
         'Sample enable
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , &B00000100
         waitms 20
        'Start
         Cpu_write Reg_select , SCOPE_STATUS_Reg
         Cpu_write Reg_data , &B00000001
         waitms 100
      End If


      'SCOPE status kiirasa
      Cpu_write Reg_select , SCOPE_STATUS_Reg
      x = CPU_Read( Reg_data )
      Szoveg = "Status= " + bin( x )
      Lcd_Sprint 0, 0, 6


      'Trigger_offset akkor kellene, ha  az idoalap 2-nel kissebb
      'const Trigger_offset = 0 'div >= 2
      'const Trigger_offset = 1  'div = 1
      'const Trigger_offset = 2  'div = 0
      'Trigger cim kiolvasasa
      Cpu_write Reg_select , TRIGGER_ADDR_H_Reg 'Trigger_addr hi
      x = CPU_Read( Reg_data )
      ww = x * 256
      Cpu_write Reg_select , TRIGGER_ADDR_L_Reg 'Trigger_addr lo
      x = CPU_Read( Reg_data )
      Trigger_addr = ww + x
      Trigger_addr = Trigger_addr '- Trigger_offset
      If Trigger_addr > 20479 Then Trigger_addr = Trigger_addr - 20480
      ii = Trigger_addr
      Szoveg = "Trigger addr= " + str( Trigger_addr ) + "   "
      Lcd_Sprint 0, 5, 6






      'Scope_Write_Addr
      Cpu_write Reg_select , SCOPE_W_ADDR_H_Reg ' Scope_Write_Addr high byte
      x = CPU_Read( Reg_data )
      ww = x * 256
      Cpu_write Reg_select , SCOPE_W_ADDR_L_Reg 'Scope_Write_Addr low byte
      x = CPU_Read( Reg_data )
      'x.0=0: x.1  =0
      ww = ww + x
      Szoveg = "Write_addr= " + str( ww ) + "     "
      Lcd_Sprint 0, 7, 6


      'Az ENCODER0 erteketol fuggoen a trigger pozicio virtualisan eltolodik
      'es annak megfeleloen lesz megjelenitve
      Cpu_write Reg_select , ENCODER0_POS_Reg
      x = CPU_Read( Reg_data )
      Trigger_addr = Trigger_addr - x
      Szoveg = "Trigger pos= " + str( x ) + "   "
      Lcd_Sprint 0, 4, 6



      'Layer1-en van a digitalizalt adat kirajzolasa

      'Az 0. es az 1. oszlop torlese a cikluson kivul hogy ne legyen atfedes
      LCD_Line_Draw 1, 1, 0, 0, 0, 239, 0
      LCD_Line_Draw 1, 1, 1, 0, 1, 239, 0


      'Tovabbi pontok kirajzolasa normal modban
      'PEAK DETECT mod eseten maskepp kell majd
      For jj = 1 To 200
         'A soron kovetkezo oszlop torlese
         LCD_Line_Draw 1, 1, jj, 0, jj, 239, 0
         'A soron kovetkezo adat kiolvasasa a mintatarolobol
         x = Cpu_peek( 2, Trigger_addr )
         'A koordinatak formazasa ugy hogy az origo a bal also sarok legyen
         LCD_y = 239 - x
         LCD_x = jj - 1
         'A trigger pointer novelese a kovetkezo adat kiolvasashoz, figyelve a
         'a RAM vegere.
         If Trigger_addr > 20478 Then Trigger_addr = 0 Else Incr Trigger_addr
         'A kovetkezo adat kiolvasasa a mintatarolobol
         x = Cpu_peek( 2, Trigger_addr )
         ''A koordinatak formazasa ugy hogy az origo a bal also sarok legyen
         LCD_y1 = 239 - x
         LCD_x1 = jj
         'A ket kiolvasott ertek altal meghatarozott pont osszekotese
         LCD_Line_Draw 1, 1, LCD_x, LCD_y, LCD_x1, LCD_y1, 3
      Next jj

      'A Trigger pont elott 8 byte-al a RAM kilistazasa hogy lethato legyen
      'a trigger esemeny elhelyezese a RAM-ban.
      'A "<-" mutatja a trigger pontot, de az csak 1-nel nagyobb idoalap osztas
      'eseten helyes. Ennek a megfigyelhetove tetele miatt van ez az egesz.
      II = II - 8
      For y = 0 to 18
         x = Cpu_peek( 2, ii )
         x =  x
         Szoveg = str(x)
         x = Len( Szoveg )
         If x < 2 Then Szoveg = Szoveg + " "
         If x < 3 Then Szoveg = Szoveg + " "
         If  y=7 then Szoveg = szoveg + "<-"
         Lcd_Sprint 26, y, 6
         Incr II
      Next y

   Loop Until SW3 = 0
End Sub